package com.dsic.gj_erp.ws;

import com.corundumstudio.socketio.SocketIOServer;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.context.event.ApplicationReadyEvent;
import org.springframework.context.ApplicationListener;
import org.springframework.stereotype.Component;

/**
 * 项目启动成功后，启动socket-io 服务
 * @Author manster
 * @Date 2022/6/13
 **/
@Slf4j
@Component
public class WsInitListener implements ApplicationListener<ApplicationReadyEvent> {

    private final SocketIOServer socketIOServer;

    public WsInitListener(SocketIOServer socketIOServer) {
        this.socketIOServer = socketIOServer;
    }

    @Override
    public void onApplicationEvent(ApplicationReadyEvent applicationReadyEvent) {
        socketIOServer.start();
        log.info("--------------------------------------");
        log.info("socket.io启动成功: " + socketIOServer.getConfiguration().getPort());
        log.info("--------------------------------------");
    }
}
